from compare_benchmark_performance.compare_accuracy_per_read import parse_baseless_output
from pathlib import Path
import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
import numpy as np


def main():
    bench_path = Path('/home/noord087/lustre_link/mscthesis/benchmarking/output_16s_files_3_cores')
    ground_truth = pd.read_csv('/lustre/BIF/nobackup/noord087/HoiCarlos/16Sreads_mockcommunity/ground_truth_with_read_id.csv')
    baseless_files = bench_path.glob(
        "baseless/*/output_fold*.csv")

    records = []

    markers = [f'${i}$' for i in range(11, 31)]
    markers = [r'$\mathtt{' + char.upper() + '}$' for char in 'abcdefghijklmnopqrstuvwxyz'][:20]

    for file in baseless_files:
        records.append(parse_baseless_output(file, ground_truth,
                                             for_pr_plot=True))
    df = pd.DataFrame.from_records(records, columns=['target_species', 'fold',
                                                     'precision', 'recall'])
    is_not_gingivalis = df['target_species'].apply(lambda x: False
                                            if x.find('gingivalis') > 0
                                            else True)
    df = df[is_not_gingivalis]
    df1 = df.groupby('target_species').aggregate(np.mean)
    sns.scatterplot(x='recall', y='precision', data=df1,
                    s=200, style='target_species', markers=markers)
    plt.xlim((0, 1))
    plt.ylim((0, 1))
    plt.tight_layout()
    # plt.show()
    plt.savefig('/lustre/BIF/nobackup/noord087/mscthesis/benchmarking/benchmarks_16s_3_cores/baseless_only1000/mean_pr_per_species.svg')

if __name__ == '__main__':
    main()
