import pandas as pd
from pathlib import Path
from inference.compile_model import reverse_complement
from Bio import Entrez


kmer_freqs_df = pd.read_parquet(Path(f'{__file__}/../data/ncbi_16S_bacteria_archaea_kmer_counts.parquet').resolve())
kmer_path = '/lustre/BIF/nobackup/noord087/mscthesis/baseless/baseless_250_hyperparam/kmers_in_dbs.txt'
ground_truth_df = pd.read_csv(
        '/lustre/BIF/nobackup/noord087/HoiCarlos/16Sreads_mockcommunity/ground_truth_with_read_id_and_perc_id.csv')

with open(kmer_path, 'r') as f:
    kmers = f.read().splitlines()

kmers.extend([reverse_complement(kmer) for kmer in kmers])
valid_kmers = [kmer for kmer in kmers if kmer in kmer_freqs_df.columns]
df_kmers_selected = kmer_freqs_df[valid_kmers]

# Get all species
handle = Entrez.efetch(db='nucleotide', id='NR_173698.1', retmode='xml')


# TODO convert between species in ground truth and species in kmers_freq_df